#!/usr/bin/php -Cq
<?php

   require_once('inc/IMConfigure.php');
	require_once('inc/Jabberd2.abstract.php');

	## limit to indefinite execution
	set_time_limit (0);
   
   ###
   # definitions of socket - BEGIN
   #
      define('URI', '0.0.0.0');
      define('TARGET_NON_SECURITY', TRANSPORT_NON_SECURITY . '://' . URI  . ':' . PORT_NON_SECURITY);
      define('SOCKET_NON_SECURITY', socket_create(AF_INET, SOCK_STREAM, SOL_TCP));
   #
   # definitions of socket - END
   ###
      // create a streaming socket, of type TCP/IP
      // set the option to reuse the port
      socket_set_option(SOCKET_NON_SECURITY, SOL_SOCKET, SO_REUSEADDR, 1);

      // "bind" the socket to the address to "localhost", on port $port
      // so this means that all connections on this port are now our resposibility to send/recv data, disconnect, etc..
      socket_bind(SOCKET_NON_SECURITY, 0, 8000);

      // start listen for connections
      socket_listen(SOCKET_NON_SECURITY);

   if ( !SOCKET_NON_SECURITY )
   {
      printf("NON SECURITY:\n(%d) %s", $errno_non_security, $errstr_non_security);
      exit(0);
   }

   $master = array(SOCKET_NON_SECURITY);
   $users = array();
   $send = false;

   while ( true )
   {
      $read = $master;
      $_w = NULL;
      $_e = NULL;
      //$mod_fd = @stream_select($read, $_w , $_e , READ_SOCKET_AFTER_OF );
      $mod_fd = socket_select($read, $_w = NULL, $_e = NULL, READ_SOCKET_AFTER_OF);

      if ( $mod_fd === FALSE )
      {
         break;
      }

      for ( $i = 0; $i < $mod_fd; ++$i )
      {
         if ( $read[$i] === SOCKET_NON_SECURITY )
         {
            $conn_non_security = socket_accept(SOCKET_NON_SECURITY);
            $master[] = &$conn_non_security;
         }
         else
         {
	    $sock_data = socket_read($read[$i], 1024);
            if ( strlen($sock_data) === 0 )
            {
               $key_to_del = array_search($read[$i], $master, TRUE);
               socket_close($read[$i]);
               unset($master[$key_to_del]);
            }
            else if ( $sock_data === FALSE )
            {
               $key_to_del = array_search($read[$i], $master, TRUE);
               unset($master[$key_to_del]);
            }
            else
            {
               $headers = (split("\n", $sock_data));

               preg_match('/^(GET|POST) \/(.+) HTTP\/1\.\d/U', $headers[0], $request);
               preg_match('/^Host: \w*:(.+)/', $headers[1], $host);

               $conn = &$conn_non_security;

               $request = explode(';', $request[2]);

               if ( $request[0] == CONNECT && isset($request[1]) && !isset($users[$request[1]]) )
               {
                  connect($users, $request[1]);
               }

               if ( $request[0] == CLOSE && isset($request[1]) && isset($users[$request[1]]) )
               {   
               	close($request[1]);
               }

               socket_close($read[$i]);
               unset($master[array_search($read[$i], $master)]);
            }
         }
      }	
      
      foreach ( $users as $key => $val )
      {
   		$time_now = time();
   		if ( ( $time_now - $users[$key]['timeClient'] ) < DISCONNECT_AFTERWARDS_OF )         
         {
         	readSocket($users, $key);
         }
         else
         {
				if((($time_now - $users[$key]['timeClient']) / DISCONNECT_AFTERWARDS_OF) > 2 )
				{
     				$users[$key]['jabber']->disconnect();
     				unset($users[$key]);     				
				}
				else
				{
					readSocket($users, $key);
				}         	
         }
      }
   }
	
   exit(0);

   function connect(&$pUsers, $pSession)
   {
	global $users;
		      
      $sessionpath = explode(';', session_save_path());
      foreach ( $sessionpath as $path )
      {
         $path = ( strrpos($path, '/') == strlen($path) - 1 ) ? $path : $path . '/';

         if ( file_exists($path . 'sess_' . $pSession) )
         {
            session_id($pSession);

            ob_start();
            session_start();
            ob_clean();
            ob_end_flush();

            $is_user = isset($_SESSION['phpgw_info']['instant_messenger']['user']) and isset($_SESSION['phpgw_info']['instant_messenger']['passwd']);
            if ( $is_user )
            {
               $_user     = $_SESSION['phpgw_info']['instant_messenger']['user'];
               $_pass     = $_SESSION['phpgw_info']['instant_messenger']['passwd'];
               $_server   = $_SESSION['phpgw_info']['instant_messenger']['name_jabber'];
               $_port     = $_SESSION['phpgw_info']['instant_messenger']['port_jabber'];
               $_resource = $_SESSION['phpgw_info']['instant_messenger']['resource_jabber'];
               $_time     = time();
               $_SESSION['phpgw_info']['instant_messenger']['timeClient'] = $_time;
					$_SESSION['phpgw_info']['instant_messenger']['timeServer'] = $_time;               
               $_SESSION['phpgw_info']['instant_messenger']['socket'] = NULL;
               $_SESSION['phpgw_info']['instant_messenger']['socket']['in'] = NULL;
               $_SESSION['phpgw_info']['instant_messenger']['socket']['out'] = array();
               $_SESSION['phpgw_info']['instant_messenger']['socket']['out']['message'] = NULL;
               $_SESSION['phpgw_info']['instant_messenger']['socket']['block'] = false;

               session_write_close();

               $a = new Jabberd2;
               if ( ($a->connect($_user . '@' . $_server . '/' . $_resource . ':' . $_port, $_pass)) )
               {
                  $pUsers[$pSession] = array();
                  $pUsers[$pSession]['jabber'] = $a;
                  $pUsers[$pSession]['timeClient'] = $_time;
               }
               else
               {
                  unset($a);
               }
               break;
            }
            session_write_close();
         }
      }
   }

   function close($pUser)
   {
      global $users;
      $users[$pUser]['jabber']->disconnect();
      unset($users[$pUser]);
   }

   function readSocket(&$pUsers, $pSession)
   {
      global $send;
      $sessionpath = explode(';', session_save_path());
      foreach ( $sessionpath as $path )
      {
         $path = ( strrpos($path, '/') == strlen($path) - 1 ) ? $path : $path . '/';

         if ( file_exists($path . 'sess_' . $pSession) )
         {
            session_id($pSession);

            ob_start();
            session_start();
            ob_clean();
            ob_end_flush();

            $is_user = isset($_SESSION['phpgw_info']['instant_messenger']['user']) and isset($_SESSION['phpgw_info']['instant_messenger']['passwd']);
            if ( $is_user )
            {
               $pUsers[$pSession]['timeClient'] = $_SESSION['phpgw_info']['instant_messenger']['timeClient'];
               $_SESSION['phpgw_info']['instant_messenger']['timeServer'] = time();
               
					$readSocket = @$pUsers[$pSession]['jabber']->readSocket();
               
               $connection_close_timeout = strpos($readSocket, "<stream:error");
               $connection_close_server = strpos($readSocket,"</stream:stream>");
               
               if ( ($readSocket !== false) && ($connection_close_timeout === false ) && ($connection_close_server === false ))
               {
                  $_SESSION['phpgw_info']['instant_messenger']['IM_disconnect'] = false;
                  if ( !empty($readSocket) )
                  {
                     $_SESSION['phpgw_info']['instant_messenger']['socket']['in'] .= $readSocket;
                  }

						if ( $_SESSION['phpgw_info']['instant_messenger']['socket']['out'] )
							foreach ( $_SESSION['phpgw_info']['instant_messenger']['socket']['out'] as $action => $value )
							{
								if ( $action === 'message' )
								{
									if ( !is_null($value) )
									{
										$pUsers[$pSession]['jabber']->writeSocket($value);
										$_SESSION['phpgw_info']['instant_messenger']['socket']['out']['message'] = NULL;
									}
								}
								else if ( $action === 'vcard' )
								{
									if ( !empty($value) )
									{
										foreach ( $value as $key => $val )
										{
											$pUsers[$pSession]['jabber']->getVcard($val);
											unset($_SESSION['phpgw_info']['instant_messenger']['socket']['out']['vcard'][$key]);
										}
									}
								}
								else
								{
									if ( method_exists($pUsers[$pSession]['jabber'], $action) )
										if ( $value )
											$pUsers[$pSession]['jabber']->$action($value);
										else
											$pUsers[$pSession]['jabber']->$action();
									unset($_SESSION['phpgw_info']['instant_messenger']['socket']['out'][$action]);
								}
							}
               }
               else
               {
               	$_SESSION['phpgw_info']['instant_messenger']['IM_disconnect'] = true;
               	close($pSession);               	
               }
               break;
            }
            else
            {
               close($pSession);
            }
            break;
         }
      }
      session_write_close();
   }
?>
