/**
* @AUTHOR: Alexandre Correia - alexandrecorreia [.at.] celepar [.dot.] pr [.dot.] gov [.dot.] br
* @AUTHOR: Rodrigo Souza - rodrigosouzadossantos [.at.] gmail [.dot.] com
* @COPYLEFT: GPL - http://www.gnu.org/copyleft/gpl.html
* @DATE: 10/10/2007
* @LAST CHANGE: 11/10/2007
* @BRIEF:
**/

function DragDrop()
{
	this.dragObject		= null;
	this.mouseOffset	= null;
	this.documentMouseMove	= null;
	this.documentMouseUp	= null;

}

DragDrop.prototype = {
	"drag" : function(ev, pObject)
	{
		function mouseMove(pEv, pObject, pTarget)
		{
			function getMouseOffset(pThis, target, pEv)
			{
				function getPosition(pObject)
				{
					try
					{
						var left = 0;
						var top  = 0;

						while (pObject.offsetParent)
						{
							left += pObject.offsetLeft;
							top  += pObject.offsetTop;
							pObject = pObject.offsetParent;
						}

						left += pObject.offsetLeft;
						top  += pObject.offsetTop;

						return {x:left, y:top};
					}catch(e){}
				}
				try
				{
					var ev = pEv || window.event;

					var docPos = getPosition(target);
					var mousePos = mouseCoords(ev);
					return {x:mousePos.x - docPos.x, y:mousePos.y - docPos.y};
				}
				catch(e){}
			}
			function mouseCoords(pEv)
			{
				try
				{
					var ev = pEv;
					var CoordX = "";
					var CoordY = "";

					if(ev.pageX || ev.pageY)
						return {x:ev.pageX, y:ev.pageY};

					CoordX = ev.clientX + document.body.scrollLeft - document.body.clientLeft;
					CoordY = ev.clientY + document.body.scrollTop  - document.body.clientTop;
					return { x:CoordX, y:CoordY };
				}
				catch(e){}
			}
			try
			{
				if ( pObject.mouseOffset == null )
					pObject.mouseOffset = getMouseOffset(pObject, pTarget, pEv);

				var ev = pEv || window.event;
				var mousePos = mouseCoords(ev);

				if( pObject.dragObject )
				{
					var x = mousePos.x - pObject.mouseOffset.x;
					var y = mousePos.y - pObject.mouseOffset.y;
					pObject.dragObject.style.left = ( x < 0 ) ? 0 : x;
					pObject.dragObject.style.top  = ( y < 0 ) ? 0 : y;
				}
				if ( typeof pObject.documentMouseMove == 'function' )
					pObject.documentMouseMove();
			}
			catch(e){}
		}
		function mouseUp(pObject)
		{
			try
			{
				if ( typeof pObject.documentMouseUp == 'function' )
					pObject.documentMouseUp();
				pObject.dragObject = null;
				document.onmousemove = pObject.documentMouseMove;
				document.onmouseup = pObject.documentMouseUp;
				pObject.documentMouseMove = pObject.documentMouseUp = null;
				pObject.mouseOffset = null;
			}
			catch(e){}
		}
		try
		{
			if( !pObject )
				return;

			if (typeof ev.preventDefault != 'undefined')
				ev.preventDefault();
			else
				pObject.onselectstart = new Function("return false;");

			this.mouseOffset = null;

			if ( pObject.getAttribute('dragdrop') === "true" )
			{
				var _this = this;
				pObject.style.cursor = "pointer";
				pObject.style.position = 'absolute';

				pObject.onmousemove = function(ev)
				{
					mouseMove(ev, _this, pObject);
				};

				if ( typeof document.onmousemove == 'function' && document.onmousemove != pObject.onmousemove )
					this.documentMouseMove = document.onmousemove;

				document.onmousemove = function(ev)
				{
					mouseMove(ev, _this, pObject);
				};

				pObject.onmouseup = function()
				{
					mouseUp(_this);
				};

				if ( typeof document.onmouseup == 'function' && document.onmouseup != pObject.onmouseup )
					this.documentMouseUp = document.onmouseup;

				document.onmouseup = pObject.onmouseup;

				var el = ( window.event ) ? window.event.srcElement : ev.target;

				if ( el.getAttribute('dragdrop') === "true" )
				{
					_this.dragObject  = pObject;
					return false;
				}
			}
		}
		catch(e){alert(e.description);}
	}
};

var drag_drop = new DragDrop();
